/*
 *    Copyright  1996, 1997, 1998, 1999, 2000 by Remco Treffkorn
 *    Distributed under the terms of the Q Public License. Please see
 *    the included file LICENSE.
 */

#include "config.h"
#include <stdio.h>

#include <Xm/DialogS.h>
#include <Xm/PushBG.h>
#include <Xm/PushB.h>
#include <Xm/LabelG.h>
#include <Xm/PanedW.h>
#include <Xm/Form.h>
#include <Xm/RowColumn.h>
#include <Xm/TextF.h>
#include <Xm/ToggleB.h>
#include <Xm/Frame.h>
#include <Xm/Label.h>
#include "xmap.h"
#include "debug.h"

extern Widget toplevel;

/* global variables */
Widget frame_2;
Widget frame_5;
Widget frame_6;
Widget frame_7;
Widget form_1;
Widget form_2;
Widget form_3;
Widget form_4;
Widget toggleButton_1;
Widget toggleButton_2;
Widget toggleButton_3;
Widget toggleButton_4;
Widget toggleButton_5;
Widget toggleButton_6;
Widget toggleButton_7;
Widget toggleButton_8;
Widget toggleButton_9;
Widget toggleButton_10;
Widget toggleButton_15;
Widget toggleButton_16;
Widget toggleButton_17;
Widget toggleButton_18;

Widget label_1;
Widget label_2;
Widget label_3;
Widget label_4;
Widget label_5;
Widget label_6;
Widget label_7;
Widget label_8;
Widget label_9;
Widget label_10;
Widget label_15;
Widget label_16;
Widget label_17;
Widget label_18;

typedef struct {
    char *label;
    void (*callback) ();
    XtPointer data;
} ActionAreaItem;

static void
 do_dialog(), close_dialog(), end_dialog(), activate_cb(), ok_pushed(), help();

static Widget mapdialog;


Widget GetTopShell(Widget w)
{
    while (w && !XtIsWMShell(w))
	w = XtParent(w);

    return w;
}

static int inhere = 0;

void do_map_dialog(Widget w, XtPointer client_data, XtPointer call_data)
{
    Arg args[100];
    XmString s;
    int n;
    Position x, y;
    Widget pane, rc, action_a;
    XmString string;
    extern Widget CreateActionArea();
    static ActionAreaItem action_items[] =
    {
	{"OK", ok_pushed, NULL},
	{"Cancel", close_dialog, NULL},
	{"Help", help, "Help Button"},
    };

    if (inhere)
	return;
    inhere++;

    /* The DialogShell is the Shell for this dialog.  Set it up so
     * that the "Close" button in the window manager's system menu
     * destroys the shell (it only unmaps it by default).
     */
    mapdialog = XtVaCreatePopupShell("mapdialog",
				xmDialogShellWidgetClass, GetTopShell(w),
				     XmNtitle, "Map Features",	/* give arbitrary title in wm */
				     XmNdeleteResponse, XmDESTROY,	/* system menu "Close" action */
				     XmNheight, 305,
				     XmNwidth, 330,
				     XmNminHeight, 305,
				     XmNminWidth, 330,
				     XmNmaxHeight, 305,
				     XmNmaxWidth, 330,
				     NULL);
    XtAddCallback(mapdialog, XmNdestroyCallback, (void *) end_dialog, NULL);

    /* Create the paned window as a child of the dialog.  This will
     * contain the control area and the action area
     * (created by CreateActionArea() using the action_items above).
     */
    pane = XtVaCreateWidget("pane", xmPanedWindowWidgetClass, mapdialog,
			    XmNsashWidth, 1,
			    XmNsashHeight, 1,
			    NULL);
    /* create the control area which contains a
     * Label gadget and a TextField widget.
     */
    n = 0;
    XtSetArg(args[n], XmNnoResize, True);
    n++;
//              XtSetArg(args[n], XmNheight, 250);n++;
    //              XtSetArg(args[n], XmNwidth, 325);n++;
    XtSetArg(args[n], XmNshadowThickness, 0);
    n++;
    rc = XtCreateWidget("mapbul",
			xmBulletinBoardWidgetClass, pane, args, n);



    XtVaCreateManagedWidget("Roads", xmLabelWidgetClass, rc,
			    XmNx, 18,
			    XmNy, 0,
			    XmNmarginTop, 0,
			    XmNmarginBottom, 0,
			    NULL);

    XtVaCreateManagedWidget("Placenames", xmLabelWidgetClass, rc,
			    XmNx, 173,
			    XmNy, 0,
			    XmNmarginTop, 0,
			    XmNmarginBottom, 0,
			    NULL);

    XtVaCreateManagedWidget("Water", xmLabelWidgetClass, rc,
			    XmNx, 18,
			    XmNy, 138,
			    XmNmarginTop, 0,
			    XmNmarginBottom, 0,
			    NULL);

    XtVaCreateManagedWidget("Other", xmLabelWidgetClass, rc,
			    XmNx, 173,
			    XmNy, 98,
			    XmNmarginTop, 0,
			    XmNmarginBottom, 0,
			    NULL);



/******************************************************************************/
    n = 0;
    XtSetArg(args[n], XmNy, 18);
    n++;
    XtSetArg(args[n], XmNx, 10);
    n++;
    XtSetArg(args[n], XmNheight, 120);
    n++;
    XtSetArg(args[n], XmNwidth, 150);
    n++;
    frame_2 = XtCreateManagedWidget("frame_2", xmFrameWidgetClass,
				    rc, args, n);

    n = 0;
    XtSetArg(args[n], XmNrubberPositioning, False);
    n++;
    XtSetArg(args[n], XmNresizePolicy, XmRESIZE_NONE);
    n++;
    form_4 = XtCreateManagedWidget("form_4", xmFormWidgetClass,
				   frame_2, args, n);

    n = 0;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNset,
	     GetPrivateProfileInt("Map Features", "Major Roads",
				  1, inifile));
    n++;
    toggleButton_15 = XtCreateManagedWidget("toggleButton_15",
			     xmToggleButtonWidgetClass, form_4, args, n);

    n = 0;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNlabelType, XmPIXMAP);
    n++;
    XtSetArg(args[n], XmNlabelPixmap, features[0].pmap);
    n++;
    label_15 = XtCreateManagedWidget("label_15",
				     xmLabelWidgetClass, form_4, args, n);

    n = 0;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET);
    n++;
    XtSetArg(args[n], XmNtopWidget, toggleButton_15);
    n++;
    XtSetArg(args[n], XmNset,
	     GetPrivateProfileInt("Map Features", "Minor Roads",
				  1, inifile));
    n++;
    toggleButton_16 = XtCreateManagedWidget("toggleButton_16",
			     xmToggleButtonWidgetClass, form_4, args, n);

    n = 0;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET);
    n++;
    XtSetArg(args[n], XmNtopWidget, label_15);
    n++;
    XtSetArg(args[n], XmNlabelType, XmPIXMAP);
    n++;
    XtSetArg(args[n], XmNlabelPixmap, features[1].pmap);
    n++;
    label_16 = XtCreateManagedWidget("label_16",
				     xmLabelWidgetClass, form_4, args, n);

    n = 0;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET);
    n++;
    XtSetArg(args[n], XmNtopWidget, toggleButton_16);
    n++;
    XtSetArg(args[n], XmNset,
	     GetPrivateProfileInt("Map Features", "Road Names",
				  1, inifile));
    n++;
    toggleButton_17 = XtCreateManagedWidget("toggleButton_17",
			     xmToggleButtonWidgetClass, form_4, args, n);

    n = 0;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET);
    n++;
    XtSetArg(args[n], XmNtopWidget, label_16);
    n++;
    XtSetArg(args[n], XmNlabelType, XmPIXMAP);
    n++;
    XtSetArg(args[n], XmNlabelPixmap, features[2].pmap);
    n++;
    label_17 = XtCreateManagedWidget("label_17",
				     xmLabelWidgetClass, form_4, args, n);

    n = 0;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET);
    n++;
    XtSetArg(args[n], XmNtopWidget, toggleButton_17);
    n++;
    XtSetArg(args[n], XmNset,
	     GetPrivateProfileInt("Map Features", "Route Symbols",
				  1, inifile));
    n++;
    toggleButton_18 = XtCreateManagedWidget("toggleButton_18",
			     xmToggleButtonWidgetClass, form_4, args, n);

    n = 0;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET);
    n++;
    XtSetArg(args[n], XmNtopWidget, label_17);
    n++;
    XtSetArg(args[n], XmNlabelType, XmPIXMAP);
    n++;
    XtSetArg(args[n], XmNlabelPixmap, features[3].pmap);
    n++;
    label_18 = XtCreateManagedWidget("label_18",
				     xmLabelWidgetClass, form_4, args, n);
/******************************************************************************/

    n = 0;
    XtSetArg(args[n], XmNy, 18);
    n++;
    XtSetArg(args[n], XmNx, 165);
    n++;
    XtSetArg(args[n], XmNheight, 80);
    n++;
    XtSetArg(args[n], XmNwidth, 150);
    n++;
    frame_5 = XtCreateManagedWidget("frame_5", xmFrameWidgetClass,
				    rc, args, n);

    n = 0;
    XtSetArg(args[n], XmNrubberPositioning, False);
    n++;
    XtSetArg(args[n], XmNresizePolicy, XmRESIZE_NONE);
    n++;
    form_1 = XtCreateManagedWidget("form_1", xmFormWidgetClass,
				   frame_5, args, n);

    n = 0;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNset,
	     GetPrivateProfileInt("Map Features", "Major Places",
				  1, inifile));
    n++;
    toggleButton_1 = XtCreateManagedWidget("toggleButton_1",
			     xmToggleButtonWidgetClass, form_1, args, n);

    n = 0;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNlabelType, XmPIXMAP);
    n++;
    XtSetArg(args[n], XmNlabelPixmap, features[7].pmap);
    n++;
    label_1 = XtCreateManagedWidget("label_1",
				    xmLabelWidgetClass, form_1, args, n);

    n = 0;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET);
    n++;
    XtSetArg(args[n], XmNtopWidget, toggleButton_1);
    n++;
    XtSetArg(args[n], XmNset,
	     GetPrivateProfileInt("Map Features", "Minor Places",
				  1, inifile));
    n++;
    toggleButton_2 = XtCreateManagedWidget("toggleButton_2",
			     xmToggleButtonWidgetClass, form_1, args, n);

    n = 0;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET);
    n++;
    XtSetArg(args[n], XmNtopWidget, label_1);
    n++;
    XtSetArg(args[n], XmNlabelType, XmPIXMAP);
    n++;
    XtSetArg(args[n], XmNlabelPixmap, features[8].pmap);
    n++;
    label_2 = XtCreateManagedWidget("label_2",
				    xmLabelWidgetClass, form_1, args, n);

/******************************************************************************/

    n = 0;
    XtSetArg(args[n], XmNy, 146);
    n++;
    XtSetArg(args[n], XmNx, 10);
    n++;
    XtSetArg(args[n], XmNheight, 100);
    n++;
    XtSetArg(args[n], XmNwidth, 150);
    n++;
    frame_6 = XtCreateManagedWidget("frame_6", xmFrameWidgetClass,
				    rc, args, n);

    n = 0;
    XtSetArg(args[n], XmNrubberPositioning, False);
    n++;
    XtSetArg(args[n], XmNresizePolicy, XmRESIZE_NONE);
    n++;
    form_3 = XtCreateManagedWidget("form_3", xmFormWidgetClass,
				   frame_6, args, n);

    n = 0;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNset,
	     GetPrivateProfileInt("Map Features", "Major Waters",
				  1, inifile));
    n++;
    toggleButton_7 = XtCreateManagedWidget("toggleButton_7",
			     xmToggleButtonWidgetClass, form_3, args, n);

    n = 0;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNlabelType, XmPIXMAP);
    n++;
    XtSetArg(args[n], XmNlabelPixmap, features[4].pmap);
    n++;
    label_7 = XtCreateManagedWidget("label_7",
				    xmLabelWidgetClass, form_3, args, n);

    n = 0;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET);
    n++;
    XtSetArg(args[n], XmNtopWidget, toggleButton_7);
    n++;
    XtSetArg(args[n], XmNset,
	     GetPrivateProfileInt("Map Features", "Minor Waters",
				  1, inifile));
    n++;
    toggleButton_8 = XtCreateManagedWidget("toggleButton_8",
			     xmToggleButtonWidgetClass, form_3, args, n);


    n = 0;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET);
    n++;
    XtSetArg(args[n], XmNtopWidget, label_7);
    n++;
    XtSetArg(args[n], XmNlabelType, XmPIXMAP);
    n++;
    XtSetArg(args[n], XmNlabelPixmap, features[5].pmap);
    n++;
    label_8 = XtCreateManagedWidget("label_8",
				    xmLabelWidgetClass, form_3, args, n);

    n = 0;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET);
    n++;
    XtSetArg(args[n], XmNtopWidget, toggleButton_8);
    n++;
    XtSetArg(args[n], XmNset,
	     GetPrivateProfileInt("Map Features", "Water Names",
				  1, inifile));
    n++;
    toggleButton_9 = XtCreateManagedWidget("toggleButton_9",
			     xmToggleButtonWidgetClass, form_3, args, n);


    n = 0;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET);
    n++;
    XtSetArg(args[n], XmNtopWidget, label_8);
    n++;
    XtSetArg(args[n], XmNlabelType, XmPIXMAP);
    n++;
    XtSetArg(args[n], XmNlabelPixmap, features[6].pmap);
    n++;
    label_9 = XtCreateManagedWidget("label_9",
				    xmLabelWidgetClass, form_3, args, n);


/******************************************************************************/

    n = 0;
    XtSetArg(args[n], XmNy, 106);
    n++;
    XtSetArg(args[n], XmNx, 165);
    n++;
    XtSetArg(args[n], XmNheight, 140);
    n++;
    XtSetArg(args[n], XmNwidth, 150);
    n++;
    frame_7 = XtCreateManagedWidget("frame_7", xmFrameWidgetClass,
				    rc, args, n);

    n = 0;
    XtSetArg(args[n], XmNrubberPositioning, False);
    n++;
    XtSetArg(args[n], XmNresizePolicy, XmRESIZE_NONE);
    n++;
    form_2 = XtCreateManagedWidget("form_2", xmFormWidgetClass,
				   frame_7, args, n);

    n = 0;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNset,
	     GetPrivateProfileInt("Map Features", "Railroads",
				  1, inifile));
    n++;
    toggleButton_3 = XtCreateManagedWidget("toggleButton_3",
			     xmToggleButtonWidgetClass, form_2, args, n);

    n = 0;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNlabelType, XmPIXMAP);
    n++;
    XtSetArg(args[n], XmNlabelPixmap, features[9].pmap);
    n++;
    label_3 = XtCreateManagedWidget("label_3",
				    xmLabelWidgetClass, form_2, args, n);

    n = 0;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET);
    n++;
    XtSetArg(args[n], XmNtopWidget, toggleButton_3);
    n++;
    XtSetArg(args[n], XmNset,
	     GetPrivateProfileInt("Map Features", "Urbans",
				  1, inifile));
    n++;
    toggleButton_4 = XtCreateManagedWidget("toggleButton_4",
			     xmToggleButtonWidgetClass, form_2, args, n);

    n = 0;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET);
    n++;
    XtSetArg(args[n], XmNtopWidget, label_3);
    n++;
    XtSetArg(args[n], XmNlabelType, XmPIXMAP);
    n++;
    XtSetArg(args[n], XmNlabelPixmap, features[10].pmap);
    n++;
    label_4 = XtCreateManagedWidget("label_4",
				    xmLabelWidgetClass, form_2, args, n);

    n = 0;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET);
    n++;
    XtSetArg(args[n], XmNtopWidget, toggleButton_4);
    n++;
    XtSetArg(args[n], XmNset,
	     GetPrivateProfileInt("Map Features", "Map Tints",
				  1, inifile));
    n++;
    toggleButton_5 = XtCreateManagedWidget("toggleButton_5",
			     xmToggleButtonWidgetClass, form_2, args, n);

    n = 0;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET);
    n++;
    XtSetArg(args[n], XmNtopWidget, label_4);
    n++;
    XtSetArg(args[n], XmNlabelType, XmPIXMAP);
    n++;
    XtSetArg(args[n], XmNlabelPixmap, features[11].pmap);
    n++;
    label_5 = XtCreateManagedWidget("label_5",
				    xmLabelWidgetClass, form_2, args, n);

    n = 0;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET);
    n++;
    XtSetArg(args[n], XmNtopWidget, toggleButton_5);
    n++;
    XtSetArg(args[n], XmNset,
	     GetPrivateProfileInt("Map Features", "ZIP Codes",
				  1, inifile));
    n++;
    toggleButton_6 = XtCreateManagedWidget("toggleButton_6",
			     xmToggleButtonWidgetClass, form_2, args, n);

    n = 0;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);
    n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET);
    n++;
    XtSetArg(args[n], XmNtopWidget, label_5);
    n++;
    XtSetArg(args[n], XmNlabelType, XmPIXMAP);
    n++;
    XtSetArg(args[n], XmNlabelPixmap, features[12].pmap);
    n++;
    label_6 = XtCreateManagedWidget("label_6",
				    xmLabelWidgetClass, form_2, args, n);

    XtVaGetValues(toplevel,
		  XmNx, &x,
		  XmNy, &y,
		  NULL);

    x += 70;
    y += 70;
    x = GetPrivateProfileInt("Layout", "features-xpos", x, inifile);
    y = GetPrivateProfileInt("Layout", "features-ypos", y, inifile);

    XtVaSetValues(mapdialog,
		  XmNx, x,
		  XmNy, y,
		  NULL);


    /* RowColumn is full -- now manage */
    XtManageChild(rc);

    /* Create the action area. */
    action_a = CreateActionArea(pane, action_items, XtNumber(action_items));

    XtManageChild(pane);

    XtManageChild(mapdialog);
    XtPopup(mapdialog, XtGrabNone);
}

static void end_dialog(Widget w, XtPointer client_data, XtPointer call_data)
{
    inhere = 0;
}

static void close_dialog(Widget w, XtPointer client_data, XtPointer call_data)
{
    XtDestroyWidget(mapdialog);
    inhere = 0;
}

static void ok_pushed(Widget w, XtPointer client_data, XtPointer call_data)
{
    char *one = "1";
    char *zero = "0";

    WritePrivateProfileString("Map Features", "Major Roads",
	  XmToggleButtonGetState(toggleButton_15) ? one : zero, inifile);

    WritePrivateProfileString("Map Features", "Minor Roads",
	  XmToggleButtonGetState(toggleButton_16) ? one : zero, inifile);

    WritePrivateProfileString("Map Features", "Road Names",
	  XmToggleButtonGetState(toggleButton_17) ? one : zero, inifile);

    WritePrivateProfileString("Map Features", "Route Symbols",
	  XmToggleButtonGetState(toggleButton_18) ? one : zero, inifile);



    WritePrivateProfileString("Map Features", "Major Waters",
	   XmToggleButtonGetState(toggleButton_7) ? one : zero, inifile);

    WritePrivateProfileString("Map Features", "Minor Waters",
	   XmToggleButtonGetState(toggleButton_8) ? one : zero, inifile);

    WritePrivateProfileString("Map Features", "Water Names",
	   XmToggleButtonGetState(toggleButton_9) ? one : zero, inifile);



    WritePrivateProfileString("Map Features", "Major Places",
	   XmToggleButtonGetState(toggleButton_1) ? one : zero, inifile);

    WritePrivateProfileString("Map Features", "Minor Places",
	   XmToggleButtonGetState(toggleButton_2) ? one : zero, inifile);



    WritePrivateProfileString("Map Features", "Railroads",
	   XmToggleButtonGetState(toggleButton_3) ? one : zero, inifile);

    WritePrivateProfileString("Map Features", "Urbans",
	   XmToggleButtonGetState(toggleButton_4) ? one : zero, inifile);

    WritePrivateProfileString("Map Features", "Map Tints",
	   XmToggleButtonGetState(toggleButton_5) ? one : zero, inifile);

    WritePrivateProfileString("Map Features", "ZIP Codes",
	   XmToggleButtonGetState(toggleButton_6) ? one : zero, inifile);

    WriteOutProfiles();

    XtDestroyWidget(mapdialog);

    inhere = 0;
}

static void help(Widget w, XtPointer client_data, XtPointer call_data)
{
	show_help("features.html");
}

#define TIGHTNESS 20

Widget CreateActionArea(Widget parent, ActionAreaItem * actions, int num_actions)
{
    Widget action_area, widget;
    int i;

    action_area = XtVaCreateWidget("action_area", xmFormWidgetClass, parent,
			    XmNfractionBase, TIGHTNESS * num_actions - 1,
				   XmNleftOffset, 10,
				   XmNrightOffset, 10,
				   NULL);

    for (i = 0; i < num_actions; i++) {
	widget = XtVaCreateManagedWidget(actions[i].label,
				    xmPushButtonWidgetClass, action_area,
		XmNleftAttachment, i ? XmATTACH_POSITION : XmATTACH_FORM,
					 XmNleftPosition, TIGHTNESS * i,
					 XmNtopAttachment, XmATTACH_FORM,
				      XmNbottomAttachment, XmATTACH_FORM,
					 XmNrightAttachment,
		i != num_actions - 1 ? XmATTACH_POSITION : XmATTACH_FORM,
		       XmNrightPosition, TIGHTNESS * i + (TIGHTNESS - 1),
					 XmNshowAsDefault, i == 0,
				      XmNdefaultButtonShadowThickness, 1,
					 NULL);
	if (actions[i].callback)
	    XtAddCallback(widget, XmNactivateCallback,
			  actions[i].callback, actions[i].data);
	if (i == 0) {
	    /* Set the action_area's default button to the first widget
	     * created (or, make the index a parameter to the function
	     * or have it be part of the data structure). Also, set the
	     * pane window constraint for max and min heights so this
	     * particular pane in the PanedWindow is not resizable.
	     */
	    Dimension height, h;
	    XtVaGetValues(action_area, XmNmarginHeight, &h, NULL);
	    XtVaGetValues(widget, XmNheight, &height, NULL);
	    height += 2 * h;
	    XtVaSetValues(action_area,
			  XmNdefaultButton, widget,
			  XmNpaneMaximum, height,
			  XmNpaneMinimum, height,
			  NULL);
	}
    }

    XtManageChild(action_area);

    return action_area;
}
